
Foreman - Feature #3272

Separate internal admin account from user admin accounts

10/16/2013 08:29 AM - Dominic Cleal

Status: Closed   

Priority: Normal   

Assignee: Dominic Cleal   

Category: Authentication   

Target version: 1.6.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Currently we install a default "admin" account which is used both for internal+anonymous actions, and the first user's login.  This

account can't be deleted as we need it for the former.

This use should be separated by hiding the internal admin account, then have the user either set up a new account for themselves

during installation or first access.

We can then permit the user to delete all but one admin accounts (and except our hidden one).

Related issues:

Related to Foreman - Feature #3725: Make default root password more explicit ... Closed 11/22/2013

Related to Foreman - Bug #2108: Cannot delete or rename admin user via GUI Duplicate 01/05/2013

Related to Foreman - Feature #2128: There should be a post-installation scree... New 01/15/2013

Related to Foreman - Feature #6586: Allow user-specified password in rake per... Closed 07/11/2014

Related to Foreman - Bug #6606: Can't delete a user if there's only one admin... Closed 07/14/2014

Related to Foreman - Bug #6873: Error during db:seed from 1.4 to 1.6: undefin... Closed 08/01/2014

Related to Foreman - Bug #6953: Fix bad internationalization calls in User Closed 08/06/2014

Blocked by Foreman - Refactor #3752: Move all data addition in DB migrations ... Closed 11/25/2013

Associated revisions

Revision d6b33a37 - 05/13/2014 01:47 PM - Dominic Cleal

refs #3272 - default password will be going away

Revision b6ed9c8d - 05/13/2014 04:38 PM - Tomas Strachota 

Merge pull request #117 from domcleal/3272-no-password

refs #3272 - default password will be going away

Revision e07f9a12 - 06/30/2014 07:57 AM - Dominic Cleal

fixes #3272 - allow 'admin' account to be removed and replaced

Revision 5534df90 - 06/30/2014 08:11 AM - Dominic Cleal

refs #3272 - pass admin user details into db:seed rake task

Revision 0fcebfbf - 06/30/2014 08:29 AM - Dominic Cleal

refs #3272 - print new user/password after installation

History

#1 - 11/12/2013 01:06 PM - Anonymous

- Target version set to 1.10.0
#2 - 11/22/2013 09:54 AM - Dominic Cleal

This must include having a user-selected or randomised password for the first admin account.

#3 - 11/22/2013 10:04 AM - Dominic Cleal

- Related to Feature #3725: Make default root password more explicit and configurable at install time added

#4 - 11/25/2013 04:47 PM - Dominic Cleal

- Status changed from New to Assigned

- Assignee set to Dominic Cleal

#5 - 11/25/2013 05:59 PM - Dominic Cleal

- Blocked by Refactor #3752: Move all data addition in DB migrations into a seed script added

#6 - 12/04/2013 01:11 PM - Dominic Cleal

- Target version changed from 1.10.0 to 1.9.3

#7 - 12/16/2013 07:20 PM - Dominic Cleal

I requested some feedback on foreman-dev to work out how the first user account should be populated:

https://groups.google.com/forum/#!topic/foreman-dev/8v53KusW_gw

The consensus seemed to be:

accept the initial admin password as an installer parameter, allowing it to be specified on the command line and answers file

randomise the admin password if it's not given, and force the user to reset it on first login

print the admin password after install

#8 - 01/09/2014 02:17 PM - Anonymous

- Target version deleted (1.9.3)

#9 - 02/27/2014 06:50 PM - Benjamin Papillon

- Related to Bug #2108: Cannot delete or rename admin user via GUI added

#10 - 02/28/2014 10:49 AM - Dominic Cleal

- Related to Feature #2128: There should be a post-installation screen to setup the initial username and password when login is enabled added

#11 - 03/03/2014 01:20 PM - Anonymous

- Target version set to 1.9.0

#12 - 03/25/2014 10:07 AM - Dominic Cleal

This is in progress on https://github.com/domcleal/foreman/tree/3272-admin-account, and I hope to have it up for review in sprint 22.

The main areas still to work on are: randomising the admin password via the installer and the db:seed script, ensuring admin-enabled user groups

interact properly with the changes, and possibly a forced password change when the randomised password is first used.

#13 - 03/26/2014 01:02 PM - Dominic Cleal

- Target version changed from 1.9.0 to 1.8.4

#14 - 04/24/2014 12:05 PM - Dominic Cleal

- Target version changed from 1.8.4 to 1.8.3

#15 - 05/13/2014 10:39 AM - Dominic Cleal

Please merge in the following order.

Hammer related PRs to support change of default password:

https://github.com/theforeman/hammer-cli-foreman/pull/117

https://github.com/theforeman/puppet-foreman/pull/192

https://github.com/theforeman/foreman-installer/pull/117

Core PR:
https://github.com/theforeman/foreman/pull/1445

Installer PRs for seeding:

https://github.com/theforeman/puppet-foreman/pull/190

https://github.com/theforeman/foreman-installer/pull/116

https://github.com/theforeman/foreman-bats/pull/26

#16 - 05/13/2014 02:33 PM - Dominic Cleal

- Status changed from Assigned to Ready For Testing

#17 - 05/14/2014 03:29 PM - Dominic Cleal

End to end test with all PRs applied:

[root@foreman foreman]# foreman-installer 

Installing             Done                                               [100%] [............................

..................]

  Success!

  * Foreman is running at https://foreman.example.com

      Initial credentials are admin / MBDKVR4FCUEUYbiJ

  * Foreman Proxy is running at https://foreman.example.com:8443

  * Puppetmaster is running at port 8140

  The full log is at /var/log/foreman-installer/foreman-installer.log

[root@foreman foreman]# hammer user list

---|-------|------------|-----------------

ID | LOGIN | NAME       | EMAIL           

---|-------|------------|-----------------

3  | admin | Admin User | root@example.com

---|-------|------------|-----------------

[root@foreman foreman]# curl -k -u admin:MBDKVR4FCUEUYbiJ https://foreman.example.com/api/v2/status; echo

{"result":"ok","status":200,"version":"1.6-develop","api_version":2}

#18 - 05/19/2014 12:42 PM - Anonymous

- Target version changed from 1.8.3 to 1.8.2

#19 - 06/11/2014 02:57 PM - Anonymous

- Target version changed from 1.8.2 to 1.8.1

#20 - 06/30/2014 08:00 AM - Dominic Cleal

- translation missing: en.field_release set to 10

#21 - 06/30/2014 08:03 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset e07f9a1245e3c88db7cd8031838cefe66988f1fe.

#22 - 07/21/2014 04:45 AM - Dominic Cleal

- Related to Feature #6586: Allow user-specified password in rake permissions:reset added

#23 - 07/21/2014 07:27 AM - Dominic Cleal

- Related to Bug #6606: Can't delete a user if there's only one admin account added

#24 - 08/01/2014 03:24 AM - Dominic Cleal

- Related to Bug #6873: Error during db:seed from 1.4 to 1.6: undefined method `expire_topbar_cache' for nil:NilClass added

#25 - 08/06/2014 08:17 AM - Dominic Cleal

- Related to Bug #6953: Fix bad internationalization calls in User added
